import * as _ from 'lodash';

declare global {
    interface String {
        atsStartsWith(suffix: string);
        atsEndsWith(suffix: string);
        atsHyphenate();
        atsUnhyphenate();
    }
}


Object.defineProperty(String.prototype, "atsStartsWith", {
    value: function atsStartsWith(this: string, prefix: string) {
        return this.substr(0, prefix.length) === prefix;
    },
    writable: true,
    configurable: true
});

//String.prototype.atsStartsWith = function (this: string, prefix: string) {
//    return this.substr(0, prefix.length) === prefix;
//};

Object.defineProperty(String.prototype, "atsEndsWith", {
    value: function atsEndsWith(this: string, suffix: string) {
        return this.indexOf(suffix, this.length - suffix.length) !== -1;
    },
    writable: true,
    configurable: true
});

//String.prototype.atsEndsWith = function (this: string, suffix: string) {
//    return this.indexOf(suffix, this.length - suffix.length) !== -1;
//};

//String.prototype.atsHyphenate = function (this: string) {
//    //Add hyphens before uppers and then lowercases.
//    //fooBarBaz becomes foo-bar-baz
//    //FooBarBaz becomes -foo-bar-baz
//    //Does NOT validate for anything.
//    return this.replace(/([A-Z])/g, '-$1').toLowerCase();
//};

Object.defineProperty(String.prototype, "atsHyphenate", {
    value: function atsHyphenate(this: string) {
        //Add hyphens before uppers and then lowercases.
        //fooBarBaz becomes foo-bar-baz
        //FooBarBaz becomes -foo-bar-baz
        //Does NOT validate for anything.
        return this.replace(/([A-Z])/g, '-$1').toLowerCase();
    },
    writable: true,
    configurable: true
});

//String.prototype.atsUnhyphenate = function (this: string) {
//    //foo-bar-baz becomes fooBarBaz
//    return this.replace(/-([a-z])/g, function (g) {
//        return g[1].toUpperCase();
//    });
//};

Object.defineProperty(String.prototype, "atsUnhyphenate", {
    value: function atsUnhyphenate(this: string) {
        //foo-bar-baz becomes fooBarBaz
        return this.replace(/-([a-z])/g, function (g) {
            return g[1].toUpperCase();
        });
    },
    writable: true,
    configurable: true
});